diff --git a/src/include/utils/pgstat_internal.h b/src/include/utils/pgstat_internal.h
index 51c0d06447b..e77aaf7f376 100644
--- a/src/include/utils/pgstat_internal.h
+++ b/src/include/utils/pgstat_internal.h
@@ -14,22 +14,107 @@
 #define PGSTAT_INTERNAL_H
 
 
+#include "access/xact.h"
+#include "lib/dshash.h"
+#include "lib/ilist.h"
 #include "pgstat.h"
-#include "executor/instrument.h"
+#include "storage/lwlock.h"
+#include "utils/dsa.h"
 
 
-#define PGSTAT_STAT_INTERVAL	500 /* Minimum time between stats file
-									 * updates; in milliseconds. */
-
-/* ----------
- * The initial size hints for the hash tables used in the collector.
- * ----------
+/*
+ * Types to define shared statistics structure.
+ *
+ * Per-object statistics are stored in the "shared stats" hashtable. That
+ * table's entries (PgStatShmHashEntry) contain a pointer to the actual stats
+ * data for the object (the size of the stats data varies depending on the
+ * kind of stats). The table is keyed by PgStatHashKey.
+ *
+ * Once a backend has a reference to a shared stats entry, it increments the
+ * entry's refcount. Even after stats data is dropped (e.g. due to a DROP
+ * TABLE), the entry itself can only be deleted once all references have been
+ * released.
+ *
+ * These refcounts, in combination with a backend local hashtable
+ * (pgStatSharedRefHash, with entries pointing to PgStatSharedRef) in front of
+ * the shared hash table, mean that most stats work can happen without
+ * touching the shared hash table, reducing contention.
+ *
+ * Once there are pending stats updates for a table PgStatSharedRef->pending
+ * is allocated to contain a working space for as-of-yet-unapplied stats
+ * updates. Once the stats are flushed, PgStatSharedRef->pending is freed.
+ *
+ * Each stat kind in the shared hash table has a fixed member
+ * PgStat_HashEntryHeader as the first element.
  */
-#define PGSTAT_DB_HASH_SIZE		16
-#define PGSTAT_TAB_HASH_SIZE	512
-#define PGSTAT_FUNCTION_HASH_SIZE	512
-#define PGSTAT_SUBSCRIPTION_HASH_SIZE	32
-#define PGSTAT_REPLSLOT_HASH_SIZE	32
+
+/* struct for shared statistics hash entry key. */
+typedef struct PgStatHashKey
+{
+	PgStatKind	kind;			/* statistics entry kind */
+	Oid			dboid;		/* database ID. InvalidOid for shared objects. */
+	Oid			objoid;		/* object ID, either table or function. */
+} PgStatHashKey;
+
+/* struct for shared statistics hash entry */
+typedef struct PgStatShmHashEntry
+{
+	PgStatHashKey key;			/* hash key */
+
+	/*
+	 * If dropped is set, backends need to release their references so that
+	 * the memory for the entry can be freed.
+	 */
+	bool		dropped;
+
+	/*
+	 * Refcount managing lifetime of the entry itself (as opposed to the
+	 * dshash entry pointing to it). The stats lifetime has to be separate
+	 * from the hash table entry lifetime because we allow backends to point
+	 * to a stats entry without holding a hash table lock (and some other
+	 * reasons).
+	 *
+	 * As long as the entry is not dropped 1 is added to the refcount
+	 * representing that it should not be dropped. In addition each backend
+	 * that has a reference to the entry needs to increment the refcount as
+	 * long as it does.
+	 *
+	 * When the refcount reaches 0 the entry needs to be freed.
+	 */
+	pg_atomic_uint32  refcount;
+
+	LWLock		lock;
+	dsa_pointer body;			/* pointer to shared stats in
+								 * PgStat_StatEntryHeader */
+} PgStatShmHashEntry;
+
+/*
+ * Common header struct for PgStatShm_Stat*Entry.
+ */
+typedef struct PgStatShm_StatEntryHeader
+{
+	uint32		magic;				/* just a validity cross-check */
+} PgStatShm_StatEntryHeader;
+
+/*
+ * A backend local reference to a shared stats entry. As long as at least one
+ * such reference exists, the shared stats entry will not be released.
+ *
+ * If there are pending stats update to the shared stats, these are stored in
+ * ->pending.
+ */
+typedef struct PgStatSharedRef
+{
+	/*
+	 * Pointers to both the hash table entry pgStatSharedHash, and the stats
+	 * (as a local pointer, to avoid dsa_get_address()).
+	 */
+	PgStatShmHashEntry *shared_entry;
+	PgStatShm_StatEntryHeader *shared_stats;
+
+	dlist_node	pending_node;	/* membership in pgStatPending list */
+	void	   *pending;		/* the pending data itself */
+} PgStatSharedRef;
 
 
 /*
@@ -43,6 +128,16 @@ typedef struct PgStat_SubXactStatus
 
 	struct PgStat_SubXactStatus *prev;	/* higher-level subxact if any */
 
+	/*
+	 * Dropping the statistics for objects that dropped transactionally itself
+	 * needs to be transactional. Therefore we collect the stats dropped in
+	 * the current (sub-)transaction and only execute the stats drop when we
+	 * know if the transaction commits/aborts. To handle replicas and crashes,
+	 * stats drops are included in commit records.
+	 */
+	dlist_head	pending_drops;
+	int			pending_drops_count;
+
 	/*
 	 * Tuple insertion/deletion counts for an open transaction can't be
 	 * propagated into PgStat_TableStatus counters until we know if it is
@@ -55,10 +150,64 @@ typedef struct PgStat_SubXactStatus
 } PgStat_SubXactStatus;
 
 
+/*
+ * Metadata for a specific kinds of statistics.
+ */
+typedef struct pgstat_kind_info
+{
+	/*
+	 * Is this kind of stats global (i.e. a precise number exists)
+	 * or not (e.g. tables).
+	 */
+	bool is_global : 1;
+
+	/*
+	 * Can stats of this kind be accessed from another database? Determines
+	 * whether a stats object gets included in stats snapshots.
+	 */
+	bool accessed_across_databases : 1;
+
+	/*
+	 * The size of an entry in the shared stats hash table (pointed to by
+	 * PgStatShmHashEntry->body).
+	 */
+	uint32 shared_size;
+
+	/*
+	 * The offset/size of the statistics inside the shared stats entry. This
+	 * is used to e.g. avoid touching lwlocks when serializing / restoring
+	 * stats snapshot serialized to / from disk respectively.
+	 */
+	uint32 shared_data_off;
+	uint32 shared_data_len;
+
+	/*
+	 * The size of the pending data for this kind. E.g. how large
+	 * PgStatPendingEntry->pending is. Used for allocations.
+	 *
+	 * -1 signal that an entry of this kind should never have a pending entry.
+	 */
+	uint32 pending_size;
+
+	/*
+	 * For global statistics: Fetch a snapshot of appropriate global stats.
+	 */
+	void (*snapshot_cb)(void);
+
+	/*
+	 * For variable number stats: flush pending stats.
+	 */
+	bool (*flush_pending_cb)(PgStatSharedRef *sr, bool nowait);
+} pgstat_kind_info;
+
+
 /*
  * List of SLRU names that we keep stats for.  There is no central registry of
  * SLRUs, so we use this fixed list instead.  The "other" entry is used for
  * all SLRUs without an explicit entry (e.g. SLRUs in extensions).
+ *
+ * This is only defined here so that SLRU_NUM_ELEMENTS is known for later type
+ * definitions.
  */
 static const char *const slru_names[] = {
 	"CommitTs",
@@ -74,13 +223,177 @@ static const char *const slru_names[] = {
 #define SLRU_NUM_ELEMENTS	lengthof(slru_names)
 
 
+typedef struct PgStatShmemGlobal
+{
+	void   *raw_dsa_area;
+
+	/*
+	 * Stats for objects for which a variable number exists are kept in this
+	 * shared hash table. See comment above PgStatKind for details.
+	 */
+	dshash_table_handle hash_handle;	/* shared dbstat hash */
+
+	/* Has the stats system already been shut down? Just a debugging check. */
+	bool is_shutdown;
+
+	/*
+	 * Whenever the for a dropped stats entry could not be freed (because
+	 * backends still have references), this is incremented, causing backends
+	 * to run pgstat_lookup_cache_gc(), allowing that memory to be reclaimed.
+	 */
+	pg_atomic_uint64 gc_count;
+
+	/*
+	 * Global stats structs.
+	 *
+	 * For the various "changecount" members check the definition of struct
+	 * PgBackendStatus for some explanation.
+	 */
+	struct
+	{
+		PgStat_ArchiverStats stats;
+		uint32 changecount;
+		PgStat_ArchiverStats reset_offset;	/* protected by StatsLock */
+	} archiver;
+
+	struct
+	{
+		PgStat_BgWriterStats stats;
+		uint32 changecount;
+		PgStat_BgWriterStats reset_offset;	/* protected by StatsLock */
+	} bgwriter;
+
+	struct
+	{
+		PgStat_CheckpointerStats stats;
+		uint32 changecount;
+		PgStat_CheckpointerStats reset_offset;	/* protected by StatsLock */
+	} checkpointer;
+
+	struct
+	{
+		LWLock		lock;
+		PgStat_StatReplSlotEntry *stats;
+	} replslot;
+
+	struct
+	{
+		LWLock		lock;
+		PgStat_SLRUStats stats[SLRU_NUM_ELEMENTS];
+#define SizeOfSlruStats sizeof(PgStat_SLRUStats[SLRU_NUM_ELEMENTS])
+	} slru;
+
+	struct
+	{
+		LWLock		lock;
+		PgStat_WalStats stats;
+	} wal;
+} PgStatShmemGlobal;
+
+
+/* ----------
+ * Types and definitions for different kinds of stats
+ *
+ * AFIXME: Can we get rid of these, and instead just have one type that's
+ * cast?
+ * ----------
+ */
+
+typedef struct PgStatShm_StatDBEntry
+{
+	PgStatShm_StatEntryHeader header;
+	PgStat_StatDBEntry stats;
+} PgStatShm_StatDBEntry;
+
+typedef struct PgStatShm_StatTabEntry
+{
+	PgStatShm_StatEntryHeader header;
+	PgStat_StatTabEntry stats;
+} PgStatShm_StatTabEntry;
+
+typedef struct PgStatShm_StatFuncEntry
+{
+	PgStatShm_StatEntryHeader header;
+	PgStat_StatFuncEntry stats;
+} PgStatShm_StatFuncEntry;
+
+typedef struct PgStatShm_StatSubEntry
+{
+	PgStatShm_StatEntryHeader header;
+	PgStat_StatSubEntry stats;
+} PgStatShm_StatSubEntry;
+
+
+/* ----------
+ * Cached statistics snapshot
+ * ----------
+ */
+
+typedef struct PgStatSnapshot
+{
+	PgStatsFetchConsistency mode;
+
+	/* time at which snapshot was taken */
+	TimestampTz snapshot_timestamp;
+
+	bool global_valid[PGSTAT_KIND_LAST + 1];
+
+	PgStat_ArchiverStats archiver;
+
+	PgStat_BgWriterStats bgwriter;
+
+	PgStat_CheckpointerStats checkpointer;
+
+	int replslot_count;
+	PgStat_StatReplSlotEntry *replslot;
+
+	PgStat_SLRUStats slru[SLRU_NUM_ELEMENTS];
+
+	PgStat_WalStats wal;
+
+	struct pgstat_snapshot_hash *stats;
+} PgStatSnapshot;
+
+
+/*
+ * Inline functions defined further below.
+ */
+
+static inline void changecount_before_write(uint32 *cc);
+static inline void changecount_after_write(uint32 *cc);
+static inline uint32 changecount_before_read(uint32 *cc);
+static inline bool changecount_after_read(uint32 *cc, uint32 cc_before);
+
+static inline void pgstat_copy_global_stats(void *dst, void *src, size_t len,
+											uint32 *cc);
+
+
 /*
  * Functions in pgstat.c
  */
 
+extern PgStatSharedRef *pgstat_shared_ref_get(PgStatKind kind,
+											  Oid dboid, Oid objoid,
+											  bool create);
+extern bool pgstat_shared_stat_lock(PgStatSharedRef *shared_ref, bool nowait);
+extern void pgstat_shared_stat_unlock(PgStatSharedRef *shared_ref);
+extern PgStatSharedRef *pgstat_shared_stat_locked(PgStatKind kind,
+												  Oid dboid,
+												  Oid objoid,
+												  bool nowait);
+
+extern PgStatSharedRef *pgstat_pending_prepare(PgStatKind kind, Oid dboid, Oid objoid);
+extern PgStatSharedRef *pgstat_pending_fetch(PgStatKind kind, Oid dboid, Oid objoid);
+
 extern PgStat_SubXactStatus *pgstat_xact_stack_level_get(int nest_level);
-extern void pgstat_setheader(PgStat_MsgHdr *hdr, StatMsgType mtype);
-extern void pgstat_send(void *msg, int len);
+
+extern void pgstat_schedule_create(PgStatKind kind, Oid dboid, Oid objoid);
+extern void pgstat_schedule_drop(PgStatKind kind, Oid dboid, Oid objoid);
+extern void pgstat_drop_database_and_contents(Oid dboid);
+
+extern void* pgstat_fetch_entry(PgStatKind kind, Oid dboid, Oid objoid);
+extern void pgstat_snapshot_global(PgStatKind kind);
+
 #ifdef USE_ASSERT_CHECKING
 extern void pgstat_assert_is_up(void);
 #else
@@ -92,42 +405,60 @@ extern void pgstat_assert_is_up(void);
  * Functions in pgstat_database.c
  */
 
+extern bool pgstat_flush_database(PgStatSharedRef *shared_ref, bool nowait);
+extern void pgstat_update_dbstats(TimestampTz now);
 extern void AtEOXact_PgStat_Database(bool isCommit, bool parallel);
-extern void pgstat_update_dbstats(PgStat_MsgTabstat *tsmsg, TimestampTz now);
 extern void pgstat_report_disconnect(Oid dboid);
+extern PgStat_StatDBEntry *pgstat_pending_db_prepare(Oid dboid);
 
 
 /*
  * Functions in pgstat_function.c
  */
 
-extern void pgstat_send_funcstats(void);
+extern bool pgstat_flush_function(PgStatSharedRef *shared_ref, bool nowait);
 
 
 /*
  * Functions in pgstat_global.c
  */
 
-extern void pgstat_send_slru(void);
+extern void pgstat_snapshot_archiver(void);
+extern void pgstat_snapshot_bgwriter(void);
+extern void pgstat_snapshot_checkpointer(void);
+extern void pgstat_snapshot_replslot(void);
+extern bool pgstat_flush_slru(bool nowait);
+extern void pgstat_snapshot_slru(void);
+extern bool pgstat_flush_wal(bool nowait);
+extern bool walstats_pending(void);
 extern void pgstat_wal_initialize(void);
+extern void pgstat_snapshot_wal(void);
 
 
 /*
  * Functions in pgstat_relation.c
  */
 
-extern void pgstat_send_tabstats(TimestampTz now, bool disconnect);
+extern bool pgstat_flush_relation(PgStatSharedRef *shared_ref, bool nowait);
 extern void AtEOXact_PgStat_Relations(PgStat_SubXactStatus *xact_state, bool isCommit);
 extern void AtEOSubXact_PgStat_Relations(PgStat_SubXactStatus *xact_state, bool isCommit, int nestDepth);
 extern void AtPrepare_PgStat_Relations(PgStat_SubXactStatus *xact_state);
 extern void PostPrepare_PgStat_Relations(PgStat_SubXactStatus *xact_state);
 
 
+/*
+ * Functions in pgstat_subscription.c
+ */
+
+extern bool pgstat_flush_subscription(PgStatSharedRef *shared_ref, bool nowait);
+
+
 /*
  * Variables in pgstat.c
  */
 
-extern pgsocket pgStatSock;
+extern PgStatShmemGlobal *pgStatShmem;
+extern PgStatSnapshot stats_snapshot;
 
 
 /*
@@ -139,10 +470,10 @@ extern int	pgStatXactRollback;
 
 
 /*
- * Variables in pgstat_functions.c
+ * Variables in pgstat_global.c
  */
 
-extern bool have_function_stats;
+extern bool have_slrustats;
 
 
 /*
@@ -153,10 +484,89 @@ extern WalUsage prevWalUsage;
 
 
 /*
- * Variables in pgstat_relation.c
+ * Implementation of inline functions declared above.
  */
 
-extern bool have_relation_stats;
+/*
+ * Helpers for changecount manipulation. See comments around struct
+ * PgBackendStatus for details.
+ */
+
+static inline void
+changecount_before_write(uint32 *cc)
+{
+	Assert((*cc & 1) == 0);
+
+	START_CRIT_SECTION();
+	(*cc)++;
+	pg_write_barrier();
+}
+
+static inline void
+changecount_after_write(uint32 *cc)
+{
+	Assert((*cc & 1) == 1);
+
+	pg_write_barrier();
+
+	(*cc)++;
+
+	END_CRIT_SECTION();
+}
+
+static inline uint32
+changecount_before_read(uint32 *cc)
+{
+	uint32 before_cc = *cc;
+
+	CHECK_FOR_INTERRUPTS();
+
+	pg_read_barrier();
+
+	return before_cc;
+}
+
+/*
+ * Returns true if the read succeeded, false if it needs to be repeated.
+ */
+static inline bool
+changecount_after_read(uint32 *cc, uint32 before_cc)
+{
+	uint32 after_cc;
+
+	pg_read_barrier();
+
+	after_cc = *cc;
+
+	/* was a write in progress when we started? */
+	if (before_cc & 1)
+		return false;
+
+	/* did writes start and complete while we read? */
+	return before_cc == after_cc;
+}
+
+
+/*
+ * pgstat_copy_global_stats - helper function for functions
+ *           pgstat_fetch_stat_*() and pgstat_reset_shared_counters().
+ *
+ * Copies out the specified memory area following change-count protocol.
+ */
+static inline void
+pgstat_copy_global_stats(void *dst, void *src, size_t len,
+						 uint32 *cc)
+{
+	uint32 cc_before;
+
+	do
+	{
+		cc_before = changecount_before_read(cc);
+
+		memcpy(dst, src, len);
+	}
+	while (!changecount_after_read(cc, cc_before));
+}
 
 
 #endif							/* PGSTAT_INTERNAL_H */
diff --git a/src/include/utils/timeout.h b/src/include/utils/timeout.h
index 099f91c61da..c068986d09a 100644
--- a/src/include/utils/timeout.h
+++ b/src/include/utils/timeout.h
@@ -32,6 +32,7 @@ typedef enum TimeoutId
 	STANDBY_LOCK_TIMEOUT,
 	IDLE_IN_TRANSACTION_SESSION_TIMEOUT,
 	IDLE_SESSION_TIMEOUT,
+	IDLE_STATS_UPDATE_TIMEOUT,
 	CLIENT_CONNECTION_CHECK_TIMEOUT,
 	STARTUP_PROGRESS_TIMEOUT,
 	/* First user-definable timeout reason */
diff --git a/src/include/utils/wait_event.h b/src/include/utils/wait_event.h
index 395d325c5fe..7cf1a71e353 100644
--- a/src/include/utils/wait_event.h
+++ b/src/include/utils/wait_event.h
@@ -42,7 +42,7 @@ typedef enum
 	WAIT_EVENT_CHECKPOINTER_MAIN,
 	WAIT_EVENT_LOGICAL_APPLY_MAIN,
 	WAIT_EVENT_LOGICAL_LAUNCHER_MAIN,
-	WAIT_EVENT_PGSTAT_MAIN,
+	WAIT_EVENT_READING_STATS_FILE,
 	WAIT_EVENT_RECOVERY_WAL_STREAM,
 	WAIT_EVENT_SYSLOGGER_MAIN,
 	WAIT_EVENT_WAL_RECEIVER_MAIN,
diff --git a/src/backend/access/heap/heapam_handler.c b/src/backend/access/heap/heapam_handler.c
index 39ef8a0b77d..911a76228d5 100644
--- a/src/backend/access/heap/heapam_handler.c
+++ b/src/backend/access/heap/heapam_handler.c
@@ -1089,8 +1089,8 @@ heapam_scan_analyze_next_tuple(TableScanDesc scan, TransactionId OldestXmin,
 				 * our own.  In this case we should count and sample the row,
 				 * to accommodate users who load a table and analyze it in one
 				 * transaction.  (pgstat_report_analyze has to adjust the
-				 * numbers we send to the stats collector to make this come
-				 * out right.)
+				 * numbers we report to the activity stats facility to make
+				 * this come out right.)
 				 */
 				if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(targtuple->t_data)))
 				{
diff --git a/src/backend/access/heap/vacuumlazy.c b/src/backend/access/heap/vacuumlazy.c
index 40101e0cb82..c54b7ea94e6 100644
--- a/src/backend/access/heap/vacuumlazy.c
+++ b/src/backend/access/heap/vacuumlazy.c
@@ -558,7 +558,7 @@ heap_vacuum_rel(Relation rel, VacuumParams *params,
 	/*
 	 * Report results to the stats collector, too.
 	 *
-	 * Deliberately avoid telling the stats collector about LP_DEAD items that
+	 * Deliberately avoid telling the stats subsystem about LP_DEAD items that
 	 * remain in the table due to VACUUM bypassing index and heap vacuuming.
 	 * ANALYZE will consider the remaining LP_DEAD items to be dead "tuples".
 	 * It seems like a good idea to err on the side of not vacuuming again too
diff --git a/src/backend/access/rmgrdesc/xactdesc.c b/src/backend/access/rmgrdesc/xactdesc.c
index 025d556f6ce..a0ba66ac034 100644
--- a/src/backend/access/rmgrdesc/xactdesc.c
+++ b/src/backend/access/rmgrdesc/xactdesc.c
@@ -84,6 +84,17 @@ ParseCommitRecord(uint8 info, xl_xact_commit *xlrec, xl_xact_parsed_commit *pars
 		data += xl_relfilenodes->nrels * sizeof(RelFileNode);
 	}
 
+	if (parsed->xinfo & XACT_XINFO_HAS_DROPPED_STATS)
+	{
+		xl_xact_dropped_stats *xl_drops = (xl_xact_dropped_stats *) data;
+
+		parsed->ndroppedstats = xl_drops->ndropped;
+		parsed->droppedstats = xl_drops->dropped_stats;
+
+		data += MinSizeOfXactDroppedStats;
+		data += xl_drops->ndropped * sizeof(PgStat_DroppedStatsItem);
+	}
+
 	if (parsed->xinfo & XACT_XINFO_HAS_INVALS)
 	{
 		xl_xact_invals *xl_invals = (xl_xact_invals *) data;
@@ -179,6 +190,17 @@ ParseAbortRecord(uint8 info, xl_xact_abort *xlrec, xl_xact_parsed_abort *parsed)
 		data += xl_relfilenodes->nrels * sizeof(RelFileNode);
 	}
 
+	if (parsed->xinfo & XACT_XINFO_HAS_DROPPED_STATS)
+	{
+		xl_xact_dropped_stats *xl_drops = (xl_xact_dropped_stats *) data;
+
+		parsed->ndroppedstats = xl_drops->ndropped;
+		parsed->droppedstats = xl_drops->dropped_stats;
+
+		data += MinSizeOfXactDroppedStats;
+		data += xl_drops->ndropped * sizeof(PgStat_DroppedStatsItem);
+	}
+
 	if (parsed->xinfo & XACT_XINFO_HAS_TWOPHASE)
 	{
 		xl_xact_twophase *xl_twophase = (xl_xact_twophase *) data;
@@ -244,6 +266,12 @@ ParsePrepareRecord(uint8 info, xl_xact_prepare *xlrec, xl_xact_parsed_prepare *p
 	parsed->abortnodes = (RelFileNode *) bufptr;
 	bufptr += MAXALIGN(xlrec->nabortrels * sizeof(RelFileNode));
 
+	parsed->droppedstats = (PgStat_DroppedStatsItem *) bufptr;
+	bufptr += MAXALIGN(xlrec->ncommitdroppedstats * sizeof(PgStat_DroppedStatsItem));
+
+	parsed->abortdroppedstats = (PgStat_DroppedStatsItem *) bufptr;
+	bufptr += MAXALIGN(xlrec->nabortdroppedstats * sizeof(PgStat_DroppedStatsItem));
+
 	parsed->msgs = (SharedInvalidationMessage *) bufptr;
 	bufptr += MAXALIGN(xlrec->ninvalmsgs * sizeof(SharedInvalidationMessage));
 }
@@ -280,6 +308,25 @@ xact_desc_subxacts(StringInfo buf, int nsubxacts, TransactionId *subxacts)
 	}
 }
 
+static void
+xact_desc_dropped_stats(StringInfo buf, const char *label,
+						int ndropped, PgStat_DroppedStatsItem *dropped_stats)
+{
+	int			i;
+
+	if (ndropped > 0)
+	{
+		appendStringInfo(buf, "; %sdropped stats:", label);
+		for (i = 0; i < ndropped; i++)
+		{
+			appendStringInfo(buf, " %u/%u/%u",
+							 dropped_stats[i].kind,
+							 dropped_stats[i].dboid,
+							 dropped_stats[i].objoid);
+		}
+	}
+}
+
 static void
 xact_desc_commit(StringInfo buf, uint8 info, xl_xact_commit *xlrec, RepOriginId origin_id)
 {
@@ -295,6 +342,7 @@ xact_desc_commit(StringInfo buf, uint8 info, xl_xact_commit *xlrec, RepOriginId
 
 	xact_desc_relations(buf, "rels", parsed.nrels, parsed.xnodes);
 	xact_desc_subxacts(buf, parsed.nsubxacts, parsed.subxacts);
+	xact_desc_dropped_stats(buf, "", parsed.ndroppedstats, parsed.droppedstats);
 
 	standby_desc_invalidations(buf, parsed.nmsgs, parsed.msgs, parsed.dbId,
 							   parsed.tsId,
@@ -338,6 +386,8 @@ xact_desc_abort(StringInfo buf, uint8 info, xl_xact_abort *xlrec, RepOriginId or
 						 LSN_FORMAT_ARGS(parsed.origin_lsn),
 						 timestamptz_to_str(parsed.origin_timestamp));
 	}
+
+	xact_desc_dropped_stats(buf, "", parsed.ndroppedstats, parsed.droppedstats);
 }
 
 static void
@@ -353,6 +403,8 @@ xact_desc_prepare(StringInfo buf, uint8 info, xl_xact_prepare *xlrec, RepOriginI
 	xact_desc_relations(buf, "rels(commit)", parsed.nrels, parsed.xnodes);
 	xact_desc_relations(buf, "rels(abort)", parsed.nabortrels,
 						parsed.abortnodes);
+	xact_desc_dropped_stats(buf, "commit ", parsed.ndroppedstats, parsed.droppedstats);
+	xact_desc_dropped_stats(buf, "abort ", parsed.nabortdroppedstats, parsed.abortdroppedstats);
 	xact_desc_subxacts(buf, parsed.nsubxacts, parsed.subxacts);
 
 	standby_desc_invalidations(buf, parsed.nmsgs, parsed.msgs, parsed.dbId,
diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
index 874c8ed1256..c2aa88428de 100644
--- a/src/backend/access/transam/twophase.c
+++ b/src/backend/access/transam/twophase.c
@@ -205,6 +205,8 @@ static void RecordTransactionCommitPrepared(TransactionId xid,
 											TransactionId *children,
 											int nrels,
 											RelFileNode *rels,
+											int ndroppedstats,
+											PgStat_DroppedStatsItem *droppedstats,
 											int ninvalmsgs,
 											SharedInvalidationMessage *invalmsgs,
 											bool initfileinval,
@@ -214,6 +216,8 @@ static void RecordTransactionAbortPrepared(TransactionId xid,
 										   TransactionId *children,
 										   int nrels,
 										   RelFileNode *rels,
+										   int ndroppedstats,
+										   PgStat_DroppedStatsItem *droppedstats,
 										   const char *gid);
 static void ProcessRecords(char *bufptr, TransactionId xid,
 						   const TwoPhaseCallback callbacks[]);
@@ -1046,6 +1050,8 @@ StartPrepare(GlobalTransaction gxact)
 	TransactionId *children;
 	RelFileNode *commitrels;
 	RelFileNode *abortrels;
+	PgStat_DroppedStatsItem *abortdroppedstats = NULL;
+	PgStat_DroppedStatsItem *commitdroppedstats = NULL;
 	SharedInvalidationMessage *invalmsgs;
 
 	/* Initialize linked list */
@@ -1071,6 +1077,10 @@ StartPrepare(GlobalTransaction gxact)
 	hdr.nsubxacts = xactGetCommittedChildren(&children);
 	hdr.ncommitrels = smgrGetPendingDeletes(true, &commitrels);
 	hdr.nabortrels = smgrGetPendingDeletes(false, &abortrels);
+	hdr.ncommitdroppedstats =
+		pgstat_pending_stats_drops(true, &commitdroppedstats);
+	hdr.nabortdroppedstats =
+		pgstat_pending_stats_drops(false, &abortdroppedstats);
 	hdr.ninvalmsgs = xactGetCommittedInvalidationMessages(&invalmsgs,
 														  &hdr.initfileinval);
 	hdr.gidlen = strlen(gxact->gid) + 1;	/* Include '\0' */
@@ -1101,6 +1111,20 @@ StartPrepare(GlobalTransaction gxact)
 		save_state_data(abortrels, hdr.nabortrels * sizeof(RelFileNode));
 		pfree(abortrels);
 	}
+	if (hdr.ncommitdroppedstats > 0)
+	{
+		save_state_data(commitdroppedstats,
+						hdr.ncommitdroppedstats
+						* sizeof(PgStat_DroppedStatsItem));
+		pfree(commitdroppedstats);
+	}
+	if (hdr.nabortdroppedstats > 0)
+	{
+		save_state_data(abortdroppedstats,
+						hdr.nabortdroppedstats
+						* sizeof(PgStat_DroppedStatsItem));
+		pfree(abortdroppedstats);
+	}
 	if (hdr.ninvalmsgs > 0)
 	{
 		save_state_data(invalmsgs,
@@ -1471,6 +1495,8 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	RelFileNode *abortrels;
 	RelFileNode *delrels;
 	int			ndelrels;
+	PgStat_DroppedStatsItem *commitdroppedstats;
+	PgStat_DroppedStatsItem *abortdroppedstats;
 	SharedInvalidationMessage *invalmsgs;
 
 	/*
@@ -1505,6 +1531,12 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	bufptr += MAXALIGN(hdr->ncommitrels * sizeof(RelFileNode));
 	abortrels = (RelFileNode *) bufptr;
 	bufptr += MAXALIGN(hdr->nabortrels * sizeof(RelFileNode));
+	commitdroppedstats = (PgStat_DroppedStatsItem*) bufptr;
+	bufptr += MAXALIGN(hdr->ncommitdroppedstats
+					   * sizeof(PgStat_DroppedStatsItem));
+	abortdroppedstats = (PgStat_DroppedStatsItem*) bufptr;
+	bufptr += MAXALIGN(hdr->nabortdroppedstats
+					   * sizeof(PgStat_DroppedStatsItem));
 	invalmsgs = (SharedInvalidationMessage *) bufptr;
 	bufptr += MAXALIGN(hdr->ninvalmsgs * sizeof(SharedInvalidationMessage));
 
@@ -1526,12 +1558,16 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 		RecordTransactionCommitPrepared(xid,
 										hdr->nsubxacts, children,
 										hdr->ncommitrels, commitrels,
+										hdr->ncommitdroppedstats,
+										commitdroppedstats,
 										hdr->ninvalmsgs, invalmsgs,
 										hdr->initfileinval, gid);
 	else
 		RecordTransactionAbortPrepared(xid,
 									   hdr->nsubxacts, children,
 									   hdr->nabortrels, abortrels,
+									   hdr->nabortdroppedstats,
+									   abortdroppedstats,
 									   gid);
 
 	ProcArrayRemove(proc, latestXid);
@@ -1567,6 +1603,13 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	/* Make sure files supposed to be dropped are dropped */
 	DropRelationFiles(delrels, ndelrels, false);
 
+	if (isCommit)
+		pgstat_perform_drops(hdr->ncommitdroppedstats,
+							 commitdroppedstats, false);
+	else
+		pgstat_perform_drops(hdr->nabortdroppedstats,
+							 abortdroppedstats, false);
+
 	/*
 	 * Handle cache invalidation messages.
 	 *
@@ -2065,6 +2108,10 @@ RecoverPreparedTransactions(void)
 		bufptr += MAXALIGN(hdr->nsubxacts * sizeof(TransactionId));
 		bufptr += MAXALIGN(hdr->ncommitrels * sizeof(RelFileNode));
 		bufptr += MAXALIGN(hdr->nabortrels * sizeof(RelFileNode));
+		bufptr += MAXALIGN(hdr->ncommitdroppedstats
+						   * sizeof(PgStat_DroppedStatsItem));
+		bufptr += MAXALIGN(hdr->nabortdroppedstats
+						   * sizeof(PgStat_DroppedStatsItem));
 		bufptr += MAXALIGN(hdr->ninvalmsgs * sizeof(SharedInvalidationMessage));
 
 		/*
@@ -2247,6 +2294,8 @@ RecordTransactionCommitPrepared(TransactionId xid,
 								TransactionId *children,
 								int nrels,
 								RelFileNode *rels,
+								int ndroppedstats,
+								PgStat_DroppedStatsItem *droppedstats,
 								int ninvalmsgs,
 								SharedInvalidationMessage *invalmsgs,
 								bool initfileinval,
@@ -2275,6 +2324,7 @@ RecordTransactionCommitPrepared(TransactionId xid,
 	 */
 	recptr = XactLogCommitRecord(committs,
 								 nchildren, children, nrels, rels,
+								 ndroppedstats, droppedstats,
 								 ninvalmsgs, invalmsgs,
 								 initfileinval,
 								 MyXactFlags | XACT_FLAGS_ACQUIREDACCESSEXCLUSIVELOCK,
@@ -2341,6 +2391,8 @@ RecordTransactionAbortPrepared(TransactionId xid,
 							   TransactionId *children,
 							   int nrels,
 							   RelFileNode *rels,
+							   int ndroppedstats,
+							   PgStat_DroppedStatsItem *droppedstats,
 							   const char *gid)
 {
 	XLogRecPtr	recptr;
@@ -2371,6 +2423,7 @@ RecordTransactionAbortPrepared(TransactionId xid,
 	recptr = XactLogAbortRecord(GetCurrentTimestamp(),
 								nchildren, children,
 								nrels, rels,
+								ndroppedstats, droppedstats,
 								MyXactFlags | XACT_FLAGS_ACQUIREDACCESSEXCLUSIVELOCK,
 								xid, gid);
 
